using System;
using System.Threading;
using System.Net;
using Bespoke.Common.Osc;

namespace Server
{
	class Program
	{
		static void Main(string[] args)
		{
			sSendMessages = true;
			sMessage = new OscMessage(new IPEndPoint(IPAddress.Loopback, Port), AliveMethod);
			Thread serverThread = new Thread(RunWorker);
			serverThread.Start();

			Console.WriteLine("OSC Server: Multicast");
			Console.WriteLine("Press any key to exit.");
			Console.ReadKey();
			sSendMessages = false;
			serverThread.Join();
		}

		static void RunWorker()
		{
			while (sSendMessages)
			{
				sMessage.Send(MulticastDestination);
				Thread.Sleep(1000);
			}
		}

		private static readonly IPAddress MulticastAddress = IPAddress.Parse("224.25.26.27");
		private static readonly int Port = 5000;
		private static readonly IPEndPoint MulticastDestination = new IPEndPoint(MulticastAddress, Port);
		private static readonly string AliveMethod = "/osctest/alive";

		private static volatile bool sSendMessages;
		private static OscMessage sMessage;
	}
}
